﻿using System;
using System.Globalization;
using VLB_RestClient.Composites.Search;



namespace VLB_RestClient.Composites
{
    /// <summary>
    /// Contains the Response-Data from an REST Search Request.
    /// </summary>
    public class JsonDataContainerSearch
    {
        public titleDataContainer[] content;
        public string lastPage = "";
        public string totalElements = "";
        public string totalPages = "";
        public string firstPage = "";
        public string last = "";
        public sortDataContainer[] sort;
        public string numberOfElements = "";
        public string first = "";
        public string size = "";
        public string number = "";
    }
}

namespace VLB_RestClient.Composites.Search
{
    //Title
    public class titleDataContainer
    {
        public string id = "";
        public string version = "";
        
        public string title = "";
        public string subTitle = "";
        public string edition = "";
        //public string collections;
        public string author = "";
        public string publisher = "";
        public string publisherMvbId = "";

        public string identifier = "";
        public string isbn = "";
        public string issn = "";
        public string gtin = "";
        public string osbnr = "";
        public string bestellnummer = "";
        public string umbreitNummer = "";
        public string cbzNummer = "";
        public string edisNummer = "";
        public string schulbuchBestellnummer = "";
        public string productType = "";
        public string productFormId = "";

        public string priceEurD = "";
        public string priceEurA = "";
        public string priceCHF = "";
        public string unpricedItemCode = "";
        public string referencePriceDE = "";

        public string state = "";
        public string publicationDate = "";
        public string createDate = "";
        public string lastModifiedDate = "";
        public string availabilityStatePublisher = "";
        public string availabilityStateFeed = "";
        





        public DateTime getPublicationDate()
        {
            return DateTime.ParseExact(publicationDate, "dd.MM.yyyy", CultureInfo.CurrentCulture);
        }



        public DateTime getCreateDate()
        {
            return DateTime.ParseExact(createDate, "dd.MM.yyyy", CultureInfo.CurrentCulture);
        }



        public DateTime getLastModifiedDate()
        {
            return DateTime.ParseExact(lastModifiedDate, "dd.MM.yyyy", CultureInfo.CurrentCulture);
        }
    }


    //Sort Fields
    public class sortDataContainer
    {
        public string direction;
        public string property;
        public bool ignoreCase;
        public bool ascending;
    }
}
